// #autoload
// #name = Quake3 CTF Sounds
// #version = 1.2
// #date = 25 January, 2003
// #author = ilys
// #warrior = ilys
// #description = Plays Quake3 sounds when the score is a draw, a win or a lose.
// #status = beta
// #category = ilys' Scripts
// #include = support/callback.cs
// #include = support/player_support.cs
// #include = support/mission_callbacks.cs
// #config = Quake3CTFSoundsGUI

$Quake3CTFSounds::Enabled = 1;
$Quake3CTFSounds::LadderScore = 0;
$Quake3CTFSounds::Delay = "0";
$Quake3CTFSounds::team1oldscore = "0";
$Quake3CTFSounds::team2oldscore = "0";

if(!isFile("prefs/Quake3CTFSoundsPrefs.cs"))
	export("$Quake3CTFSounds::*", "prefs/Quake3CTFSoundsPrefs.cs", false);
exec("prefs/Quake3CTFSoundsPrefs.cs");

package Quake3CTFSounds
{
function CTFCheckCap(%schedule)
{
	%MySelf = PlayerList.getMyName();
	%myteamId = PlayerList.getTeamByName(%MySelf);
	%team1score = ObjectiveHud.teamScore[1].getValue();
	%team2score = ObjectiveHud.teamScore[2].getValue();
	%team1caps = mFormatFloat(mAbs(%team1score/100), "%.0f");
	%team2caps = mFormatFloat(mAbs(%team2score/100), "%.0f");
	if(MissionCallback.getMissionType() $= "Capture the Flag" && %schedule && $Quake3CTFSounds::Enabled && !$newgame)
	{
		if($Quake3CTFSounds::LadderScore)
		{
			if((%team1score - %team2score) > 4)
			{
				if(%myteamId $= 1 && !$team1leads)
				{
					%handle = alxCreateSource(AudioChat, "q3winning.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 1;
					$team2leads = 0;
					$teamsdrawn = 0;
			        }
			        else if(%myteamId $= 2 && !$team1leads)
			        {
					%handle = alxCreateSource(AudioChat, "q3losing.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 0;
					$team2leads = 1;
					$teamsdrawn = 0;
			        }
			}
			else if((%team2score - %team1score) > 4)
			{
				if(%myteamId $= 2 && !$team2leads)
				{
					%handle = alxCreateSource(AudioChat, "q3winning.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 0;
					$team2leads = 1;
					$teamsdrawn = 0;
				}
				else if(%myteamId $= 1 && !$team2leads)
				{
					%handle = alxCreateSource(AudioChat, "q3losing.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 1;
					$team2leads = 0;
					$teamsdrawn = 0;
				}
			}
			else if((abs(%team1score - %team2score) < 5 || abs(%team2score - %team1score) < 5) && !$teamsdrawn)
			{
				%handle = alxCreateSource(AudioChat, "q3draw.wav");
				schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
				$teamsdrawn = 1;
			}
		}
		else
		{
			if(%team1caps > %team2caps)
			{
				if(%myteamId $= 1 && !$team1leads)
				{
					%handle = alxCreateSource(AudioChat, "q3winning.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 1;
					$team2leads = 0;
					$teamsdrawn = 0;
				}
				else if(%myteamId $= 2 && !$team1leads)
				{
					%handle = alxCreateSource(AudioChat, "q3losing.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 0;
					$team2leads = 1;
					$teamsdrawn = 0;
				}
			}
			else if(%team1caps < %team2caps)
			{
				if(%myteamId $= 2 && !$team2leads)
				{
					%handle = alxCreateSource(AudioChat, "q3winning.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 1;
					$team2leads = 0;
					$teamsdrawn = 0;
				}
				else if(%myteamId $= 1 && !$team2leads)
				{
					%handle = alxCreateSource(AudioChat, "q3losing.wav");
					schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
					$team1leads = 0;
					$team2leads = 1;
					$teamsdrawn = 0;
				}
			}
			else if((%team1caps == %team2caps || %team2caps == %team1caps) && !$teamsdrawn)
			{
				%handle = alxCreateSource(AudioChat, "q3draw.wav");
				schedule(1000*$Quake3CTFSounds::Delay, 0, alxPlay(%handle));
				$teamsdrawn = 1;
			}
		}
		$Quake3CTFSounds::team1oldscore = %team1score;
		$Quake3CTFSounds::team2oldscore = %team2score;
	}
	if(!%schedule)
		Schedule(200, 0, CTFCheckCap, 1);
}

function CTFCheckMatchStart(%msgType, %msgString)
{
	if(strstr(%msgString, "Match started!") != -1)
	{
		$team1leads = 0;
		$team2leads = 0;
		$teamsdrawn = 1;
		$newgame = 1;
		$Quake3CTFSounds::team1oldscore = "0";
		$Quake3CTFSounds::team2oldscore = "0";
	}
}

function CTFGameOver()
{
	$team1leads = 0;
	$team2leads = 0;
	$teamsdrawn = 1;
	$newgame = 1;
	$Quake3CTFSounds::team1oldscore = "0";
	$Quake3CTFSounds::team2oldscore = "0";
}

function CTFCheckClientJoin(%msgType, %msgString, %clientName, %clientId, %targetId, %isAI, %isAdmin, %isSuperAdmin, %isSmurf, %guid)
{
	if(StrStr(%msgString, "Welcome to Tribes") != -1)
	{
		$team1leads = 0;
		$team2leads = 0;
		$teamsdrawn = 1;
		$newgame = 1;
		$Quake3CTFSounds::team1oldscore = "0";
		$Quake3CTFSounds::team2oldscore = "0";
	}
}

function CTFCheckClientJoinTeam(%msgType, %msgString, %clientName, %teamName, %clientId, %teamId)
{
	%MySelf = PlayerList.getMyName();
	%myteamId = PlayerList.getTeamByName(%MySelf);
	if(%clientId $= PlayerList.getMyID() && $HudMode !$= "Observer")
	{
		if($Quake3CTFSounds::LadderScore)
		{
			if(ObjectiveHud.teamScore[1].getValue() == 0 && ObjectiveHud.teamScore[1].getValue() == 0)
			{
				$newgame = 1;
				$team1leads = 0;
				$team2leads = 0;
				$teamsdrawn = 1;
			}
			else if((ObjectiveHud.teamScore[1].getValue() - ObjectiveHud.teamScore[2].getValue()) > 4)
			{
				$newgame = 0;
				$team1leads = 1;
				$team2leads = 0;
				$teamsdrawn = 0;
			}
			else if((ObjectiveHud.teamScore[2].getValue() - ObjectiveHud.teamScore[1].getValue()) > 4)
			{
				$newgame = 0;
				$team1leads = 0;
				$team2leads = 1;
				$teamsdrawn = 0;
			}
			else
			{
				$newgame = 0;
				$team1leads = 0;
				$team2leads = 0;
				$teamsdrawn = 1;
			}
		}
		else
		{
			if(ObjectiveHud.teamScore[1].getValue() == 0 && ObjectiveHud.teamScore[1].getValue() == 0)
			{
				$newgame = 1;
				$team1leads = 0;
				$team2leads = 0;
				$teamsdrawn = 1;
			}
			else if(ObjectiveHud.teamScore[1].getValue() > ObjectiveHud.teamScore[2].getValue())
			{
				$newgame = 0;
				$team1leads = 1;
				$team2leads = 0;
				$teamsdrawn = 0;
			}
			else if(ObjectiveHud.teamScore[1].getValue() < ObjectiveHud.teamScore[2].getValue())
			{
				$newgame = 0;
				$team1leads = 0;
				$team2leads = 1;
				$teamsdrawn = 0;
			}
			else
			{
				$newgame = 0;
				$team1leads = 0;
				$team2leads = 0;
				$teamsdrawn = 1;
			}
		}

		$Quake3CTFSounds::team1oldscore = ObjectiveHud.teamScore[1].getValue();
		$Quake3CTFSounds::team2oldscore = ObjectiveHud.teamScore[2].getValue();
		CTFCheckCap();
	}
}

function CTFCheckFlagGrab()
{
	$newgame = 0;
	if(ObjectiveHud.teamScore[1].getValue() != $Quake3CTFSounds::team1oldscore && $Quake3CTFSounds::LadderScore)
		CTFCheckCap();

	if(ObjectiveHud.teamScore[2].getValue() != $Quake3CTFSounds::team2oldscore && $Quake3CTFSounds::LadderScore)
		CTFCheckCap();
}

function CTFQuake3CTFSoundsToggle(%val)
{
	if(%val) return;
	
	$Quake3CTFSounds::Enabled=!$Quake3CTFSounds::Enabled;
	if ($Quake3CTFSounds::Enabled) 
		addMessageHudLine("\c7Q3CTF Sounds active.");
	else
		addMessageHudLine("\c7Q3CTF Sounds disabled.");
}

function DispatchLaunchMode()
{
	AddMessageCallback('MsgClientJoin', CTFCheckClientJoin);
	AddMessageCallback('MsgClientJoinTeam', CTFCheckClientJoinTeam);
	AddMessageCallback('MsgMissionStart', CTFCheckMatchStart);
	AddMessageCallback('MsgGameOver', CTFGameOver);
	AddMessageCallback('MsgCTFFlagTaken', CTFCheckFlagGrab);
	AddMessageCallback('MsgCTFFlagCapped', CTFCheckCap);

	parent::DispatchLaunchMode();
}

function OptionsDlg::onWake(%this)
{
	if(!$Q3CTFSoundsBound)
	{
		$RemapName[$RemapCount]="Q3CTFSounds Toggle";
		$RemapCmd[$RemapCount]="Quake3CTFSoundsToggle";
		$RemapCount++;
		$Q3CTFSoundsBound = 1;
	}
	parent::onWake(%this);
}

function Quake3CTFSoundsSavePrefs()
{
	export("$Quake3CTFSounds::*", "prefs/Quake3CTFSoundsPrefs.cs", false);
}

function Quake3CTFSoundsGUI::OnWake()
{
	// No console spam please
}
};

activatePackage(Quake3CTFSounds);

new GuiControl(Quake3CTFSoundsGUI) {
	profile = "GuiDefaultProfile";
	horizSizing = "center";
	vertSizing = "center";
	position = "0 0";
	extent = "130 100";
	minExtent = "130 100";
	visible = "1";
	hideCursor = "0";
	bypassHideCursor = "0";
	helpTag = "0";

	new ShellFieldCtrl() {
		profile = "ShellFieldProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0 0";
		extent = "130 100";
		minExtent = "16 18";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";

		new ShellToggleButton(LadderScore) {
			profile = "ShellRadioProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 10";
			extent = "105 30";
			minExtent = "26 27";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$Quake3CTFSounds::LadderScore";
			command = "Quake3CTFSoundsSavePrefs();";
			helpTag = "0";
			text = "Ladder Score";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new GuiTextCtrl() {
			profile = "ShellMediumTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "15 40";
//			extent = "20 20";
//			minExtent = "8 8";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "Delay(seconds)";
			longTextBuffer = "0";
			maxLength = "255";
		};
		new ShellTextEditCtrl(Q3CTFSoundsDelay) {
			profile = "NewTextEditProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "10 60";
			extent = "110 30";
			minExtent = "32 30";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			variable = "$Quake3CTFSounds::Delay";
			command = "Quake3CTFSoundsSavePrefs();";
			helpTag = "0";
			longTextBuffer = "0";
			maxLength = "255";
			historySize = "0";
			password = "0";
			IRCName = "0";
			tabComplete = "0";
			glowOffset = "9 9";
		};
	};
};